-- CityBinder - Bind File Generator for City of Heroes and City of Villains
-- Copyright (C) 2005  Jeff Sheets

-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


local module = {}

function module.bindsettings(profile)
	local fps = profile.fps
	if fps == nil then
		fps = {}
		profile.fps = fps
		fps.enable = nil
		fps.bindkey = "P"
	end
	if fps.dialog then
		fps.dialog:show()
	else
		cbToolTip("Check this to enable a Frame Per Second and Network Usage Graph Toggle Bind")
		local fpsenable = cbCheckbox("Enable FPS and Netgraph Toggle Bind?",fps.enable,function(_,v) if v == 1 then fps.enable = true else fps.enable = nil end end)
		cbToolTip("Choose the Key Combo to toggle the FPS and Netgraph displays")
		local bindhbox = cbBindBox("Bindkey",fps,"bindkey",function(s) fps.bindkey = s end,"FPS Display Toggle",profile)
	
		local typdlg = iup.dialog{iup.vbox{fpsenable,bindhbox;title = "Net : FPS Display Toggle"}}
		typdlg:showxy(218,10)
		fps.dialog = typdlg
		typdlg.close_cb = function(self) fps.dialog = nil end
	end
end

function module.makebind(profile)
	local resetfile = profile.resetfile
	local fps = profile.fps
	resetfile:write(fps.bindkey..' "++showfps$$++netgraph"\n')
end

function module.bindisused(profile)
	if profile.fps == nil then return nil end
	return profile.fps.enable
end

cbAddModule(module,"FPS Display Toggle","Net")
