-- CityBinder - Bind File Generator for City of Heroes and City of Villains
-- Copyright (C) 2005  Jeff Sheets

-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


local module = {}

local function addBBind(bbinds,n,profile)
	local bbind = bbinds[n]
	local selchattext = cbToggleText("Select Chat",bbind.selchatenabled,bbind.selchat,
		function(_,v) if v == 1 then bbind.selchatenabled = true else bbind.selchatenabled = nil end end,
		function(_,c,s) bbind.selchat = s end,100,nil,300)
	local buffpower1 = cbTextBox("Buff Power",bbind.power1,function(_,c,s) bbind.power1 = s end)
	local chat1text = cbToggleText("Chat command",bbind.chat1enabled,bbind.chat1,
		function(_,v) if v == 1 then bbind.chat1enabled = true else bbind.chat1enabled = nil end end,
		function(_,c,s) bbind.chat1 = s end,100,nil,300)
	local chat3text = cbToggleText("Chat command",bbind.chat3enabled,bbind.chat3,
		function(_,v) if v == 1 then bbind.chat3enabled = true else bbind.chat3enabled = nil end end,
		function(_,c,s) bbind.chat3 = s end,100,nil,300)
	if not bbind.power3enabled then chat3text.active = "NO" end
	local buffpower3 = cbToggleText("Buff Power",bbind.power3enabled,bbind.power3,
		function(_,v)
			if v == 1 then
				bbind.power3enabled = true
				chat3text.active = "YES"
			else
				bbind.power3enabled = nil
				chat3text.active = "NO"
			end
		end,
		function(_,c,s) bbind.power3 = s end)
	if not bbind.power2enabled then buffpower3.active = "NO" end
	local chat2text = cbToggleText("Chat command",bbind.chat2enabled,bbind.chat2,
		function(_,v) if v == 1 then bbind.chat2enabled = true else bbind.chat2enabled = nil end end,
		function(_,c,s) bbind.chat2 = s end,100,nil,300)
	if not bbind.power2enabled then chat2text.active = "NO" end
	local buffpower2 = cbToggleText("Buff Power",bbind.power2enabled,bbind.power2,
		function(_,v)
			if v == 1 then
				bbind.power2enabled = true
				chat2text.active = "YES"
				buffpower3.active = "YES"
				if bbind.power3enabled then
					chat3text.active = "YES"
				end
			else
				bbind.power2enabled = nil
				chat2text.active = "NO"
				buffpower3.active = "NO"
				chat3text.active = "NO"
			end
		end,
		function(_,c,s) bbind.power2 = s end)
	local team1key = cbBindBox("Team 1 Key",bbind,"team1",function(s) bbind.team1 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Team 1 Key" end,profile)
	local team2key = cbBindBox("Team 2 Key",bbind,"team2",function(s) bbind.team2 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Team 2 Key" end,profile)
	local team3key = cbBindBox("Team 3 Key",bbind,"team3",function(s) bbind.team3 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Team 3 Key" end,profile)
	local team4key = cbBindBox("Team 4 Key",bbind,"team4",function(s) bbind.team4 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Team 4 Key" end,profile)
	local team5key = cbBindBox("Team 5 Key",bbind,"team5",function(s) bbind.team5 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Team 5 Key" end,profile)
	local team6key = cbBindBox("Team 6 Key",bbind,"team6",function(s) bbind.team6 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Team 6 Key" end,profile)
	local team7key = cbBindBox("Team 7 Key",bbind,"team7",function(s) bbind.team7 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Team 7 Key" end,profile)
	local team8key = cbBindBox("Team 8 Key",bbind,"team8",function(s) bbind.team8 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Team 8 Key" end,profile)
	local pet1key = cbBindBox("Pet 1 Key",bbind,"pet1",function(s) bbind.pet1 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Pet 1 Key" end,profile)
	local pet2key = cbBindBox("Pet 2 Key",bbind,"pet2",function(s) bbind.pet2 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Pet 2 Key" end,profile)
	local pet3key = cbBindBox("Pet 3 Key",bbind,"pet3",function(s) bbind.pet3 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Pet 3 Key" end,profile)
	local pet4key = cbBindBox("Pet 4 Key",bbind,"pet4",function(s) bbind.pet4 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Pet 4 Key" end,profile)
	local pet5key = cbBindBox("Pet 5 Key",bbind,"pet5",function(s) bbind.pet5 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Pet 5 Key" end,profile)
	local pet6key = cbBindBox("Pet 6 Key",bbind,"pet6",function(s) bbind.pet6 = s return iup.DEFAULT end,
		function() return "Buff bind "..n..": Pet 6 Key" end,profile)
	local target = cbListBox("Buffs affect...",{"Teammates","Pets","Both"},3,bbind.target,
		function(_,str,i,v)
			if v == 1 then
				bbind.target = i
				-- activate bind boxes based on the value of i.
				if i == 1 then
					team1key.active="YES"
					team2key.active="YES"
					team3key.active="YES"
					team4key.active="YES"
					team5key.active="YES"
					team6key.active="YES"
					team7key.active="YES"
					team8key.active="YES"
					pet1key.active="NO"
					pet2key.active="NO"
					pet3key.active="NO"
					pet4key.active="NO"
					pet5key.active="NO"
					pet6key.active="NO"
				elseif i == 2 then
					team1key.active="NO"
					team2key.active="NO"
					team3key.active="NO"
					team4key.active="NO"
					team5key.active="NO"
					team6key.active="NO"
					team7key.active="NO"
					team8key.active="NO"
					pet1key.active="YES"
					pet2key.active="YES"
					pet3key.active="YES"
					pet4key.active="YES"
					pet5key.active="YES"
					pet6key.active="YES"
				else
					team1key.active="YES"
					team2key.active="YES"
					team3key.active="YES"
					team4key.active="YES"
					team5key.active="YES"
					team6key.active="YES"
					team7key.active="YES"
					team8key.active="YES"
					pet1key.active="YES"
					pet2key.active="YES"
					pet3key.active="YES"
					pet4key.active="YES"
					pet5key.active="YES"
					pet6key.active="YES"
				end
			end
		end)
	if bbind.target == 1 then
		pet1key.active="NO"
		pet2key.active="NO"
		pet3key.active="NO"
		pet4key.active="NO"
		pet5key.active="NO"
		pet6key.active="NO"
	elseif bbind.target == 2 then
		team1key.active="NO"
		team2key.active="NO"
		team3key.active="NO"
		team4key.active="NO"
		team5key.active="NO"
		team6key.active="NO"
		team7key.active="NO"
		team8key.active="NO"
	end

	local delbtn = cbButton("Delete this Bind",function()
	if iup.Alarm("Confirm Deletion","Are you sure you want to delete this bind?","Yes","No") == 1 then
		table.remove(bbinds,n)
		bbinds.curset = bbinds.curset - 1
		if bbinds.curset == 0 then bbinds.curset = 1 end
		bbinds.dlg:hide()
		bbinds.dlg:destroy()
		bbinds.dlg = nil
		module.createDialog(bbinds)
		bbinds.dlg:showxy(218,10)
	end end)

	return iup.vbox{selchattext,buffpower1,chat1text,buffpower2,chat2text,buffpower3,chat3text,
		iup.hbox{iup.vbox{team1key,team2key,team3key,team4key,team5key,team6key,team7key,team8key},
			iup.vbox{target,iup.fill{},pet1key,pet2key,pet3key,pet4key,pet5key,pet6key,iup.fill{}}},delbtn
	}
end

local function newBBind() -- returns the default empty buff bind settings in table form.
	local t={}
	t.power = "Aid Other"
	t.chat = "g Casting Aid Other on $target"
	t.chatenabled = true
	t.target = 3
	t.team1 = "UNBOUND"
	t.team2 = "UNBOUND"
	t.team3 = "UNBOUND"
	t.team4 = "UNBOUND"
	t.team5 = "UNBOUND"
	t.team6 = "UNBOUND"
	t.team7 = "UNBOUND"
	t.team8 = "UNBOUND"
	t.pet1 = "UNBOUND"
	t.pet2 = "UNBOUND"
	t.pet3 = "UNBOUND"
	t.pet4 = "UNBOUND"
	t.pet5 = "UNBOUND"
	t.pet6 = "UNBOUND"
	return t
end

function module.createDialog(bbinds,profile)
	local box = {}
	for i = 1,table.getn(bbinds) do
		table.insert(box,addBBind(bbinds,i,profile))
	end
	bbinds.curset = bbinds.curset or 1
	cbToolTip("Click this to add a new bind")
	local newbindbtn = cbButton("New Buff Bind",
		function()
			table.insert(bbinds,newBBind())
			bbinds.curbind = table.getn(bbinds)
			bbinds.dlg:hide()
			bbinds.dlg:destroy()
			bbinds.dlg = nil
			module.createDialog(bbinds,profile)
			bbinds.dlg:showxy(218,10)
		end,100)
	local bbEnablePrev = "NO"
	local bbEnableNext = "NO"
	if bbinds.curset > 1 then bbEnablePrev = "YES" end
	cbToolTip("Click this to go to the previous bind")
	bbinds.prevbind = cbButton("<<",function(self)
			bbinds.curset = bbinds.curset - 1
			if bbinds.curset < 1 then bbinds.curset = 1 end
			bbinds.zbox.value = box[bbinds.curset]
			bbinds.poslabel.title = bbinds.curset.."/"..table.getn(bbinds)
			local bbEnablePrev = "NO"
			if bbinds.curset > 1 then bbEnablePrev = "YES" end
			bbinds.prevbind.active=bbEnablePrev
			local bbEnableNext = "NO"
			if bbinds.curset < table.getn(bbinds) then bbEnableNext = "YES" end
			bbinds.nextbind.active=bbEnableNext
		end,25,nil,{active=bbEnablePrev})
	if bbinds.curset < table.getn(bbinds) then bbEnableNext = "YES" end
	cbToolTip("Click this to go to the previous bind")
	bbinds.nextbind = cbButton(">>",function(self)
			bbinds.curset = bbinds.curset + 1
			if bbinds.curset > table.getn(bbinds) then bbinds.curset = table.getn(bbinds) end
			bbinds.zbox.value = box[bbinds.curset]
			bbinds.poslabel.title = bbinds.curset.."/"..table.getn(bbinds)
			local bbEnablePrev = "NO"
			if bbinds.curset > 1 then bbEnablePrev = "YES" end
			bbinds.prevbind.active=bbEnablePrev
			local bbEnableNext = "NO"
			if bbinds.curset < table.getn(bbinds) then bbEnableNext = "YES" end
			bbinds.nextbind.active=bbEnableNext
		end,25,nil,{active=bbEnableNext})
	bbinds.poslabel = iup.label{title = bbinds.curset.."/"..table.getn(bbinds);rastersize="50x";alignment="ACENTER"}
	box.value = box[bbinds.curset]
	bbinds.zbox = iup.zbox(box)
	bbinds.dlg = iup.dialog{iup.vbox{bbinds.zbox,iup.hbox{bbinds.prevbind;newbindbtn;bbinds.poslabel;bbinds.nextbind;alignment="ACENTER"};alignment="ACENTER"};title = "Gameplay : Buffer Binds"}
	bbinds.dlg.close_cb = function(self) bbinds.dlg = nil end
end

function module.bindsettings(profile)
	local buffer = profile.buffer
	if buffer == nil then
		buffer = {}
		profile.buffer = buffer
	end
	--buffer.number = buffer.number or 0
	--buffer.curset = buffer.curset or 0
	--buffer.set = buffer.set or {}
	if buffer.dlg then
		buffer.dlg:show()
	else
	
		module.createDialog(buffer,profile)
		buffer.dlg:showxy(218,10)
	end
end

function module.makebind(profile)
	local resetfile = profile.resetfile
	local buffer = profile.buffer
	local afile, bfile, cfile, dfile
	-- for each bindset, create the binds.
	for i = 1,table.getn(buffer) do
		bbind = buffer[i]
		cbMakeDirectory(profile.base..'\\buff'..i)
		local selchat = (bbind.selchat or "").."$$"
		if not bbind.selchatenabled then selchat = "" end
		local chat1 = (bbind.chat1 or "").."$$"
		if not bbind.chat1enabled then chat1 = "" end
		local chat2 = (bbind.chat2 or "").."$$"
		if not bbind.chat2enabled then chat2 = "" end
		local chat3 = (bbind.chat3 or "").."$$"
		if not bbind.chat3enabled then chat3 = "" end
		local npow = 1
		if bbind.power2enabled then
			npow = 2
			if bbind.power3enabled then npow = 3 end
		end
		if (bbind.target == 1) or (bbind.target == 3) then
			for j = 1,8 do
				resetfile:write(bbind["team"..j]..' "+ $$teamselect '..j..'$$'..selchat..'bindloadfilesilent'..profile.base..'\\buff'..i..'\\bufft'..j..'b.txt"\n')
				afile = cbOpen(profile.base..'\\buff'..i..'\\bufft'..j..'a.txt',"w")
				bfile = cbOpen(profile.base..'\\buff'..i..'\\bufft'..j..'b.txt',"w")
				afile:write(bbind["team"..j]..' "+ $$teamselect '..j..'$$'..selchat..'bindloadfilesilent'..profile.base..'\\buff'..i..'\\bufft'..j..'b.txt"\n')
				if npow == 1 then
					bfile:write(bbind["team"..j]..' " $$'..chat1..'powexecname '..bbind.power1..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\bufft'..j..'a.txt"\n')
				else
					bfile:write(bbind["team"..j]..' " $$'..chat1..'powexecname '..bbind.power1..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\bufft'..j..'c.txt"\n')
					cfile = cbOpen(profile.base..'\\buff'..i..'\\bufft'..j..'c.txt',"w")
					if npow == 2 then
						cfile:write(bbind["team"..j]..' "'..chat2..'powexecname '..bbind.power2..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\bufft'..j..'a.txt"\n')
					else
						cfile:write(bbind["team"..j]..' "+ $$'..chat2..'powexecname '..bbind.power2..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\bufft'..j..'d.txt"\n')
						dfile = cbOpen(profile.base..'\\buff'..i..'\\bufft'..j..'d.txt',"w")
						dfile:write(bbind["team"..j]..' " $$'..chat3..'powexecname '..bbind.power3..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\bufft'..j..'a.txt"\n')
						dfile:close()
					end
					cfile:close()
				end
				afile:close() bfile:close()
			end
		end
		if (bbind.target == 2) or (bbind.target == 3) then
			for j = 1,6 do
				resetfile:write(bbind["pet"..j]..' "+ $$petselect '..(j-1)..'$$'..selchat..'bindloadfilesilent'..profile.base..'\\buff'..i..'\\buffp'..j..'b.txt"\n')
				afile = cbOpen(profile.base..'\\buff'..i..'\\buffp'..j..'a.txt',"w")
				bfile = cbOpen(profile.base..'\\buff'..i..'\\buffp'..j..'b.txt',"w")
				afile:write(bbind["pet"..j]..' "+ $$petselect '..(j-1)..'$$'..selchat..'bindloadfilesilent'..profile.base..'\\buff'..i..'\\buffp'..j..'b.txt"\n')
				if npow == 1 then
					bfile:write(bbind["pet"..j]..' " $$'..chat1..'powexecname '..bbind.power1..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\buffp'..j..'a.txt"\n')
				else
					bfile:write(bbind["pet"..j]..' " $$'..chat1..'powexecname '..bbind.power1..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\buffp'..j..'c.txt"\n')
					cfile = cbOpen(profile.base..'\\buff'..i..'\\buffp'..j..'c.txt',"w")
					if npow == 2 then
						cfile:write(bbind["pet"..j]..' "'..chat2..'powexecname '..bbind.power2..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\buffp'..j..'a.txt"\n')
					else
						cfile:write(bbind["pet"..j]..' "+ $$'..chat2..'powexecname '..bbind.power2..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\buffp'..j..'d.txt"\n')
						dfile = cbOpen(profile.base..'\\buff'..i..'\\buffp'..j..'d.txt',"w")
						dfile:write(bbind["pet"..j]..' " $$'..chat3..'powexecname '..bbind.power3..'$$bindloadfilesilent'..profile.base..'\\buff'..i..'\\buffp'..j..'a.txt"\n')
						dfile:close()
					end
					cfile:close()
				end
				afile:close() bfile:close()
			end
		end
	end
end

function module.bindisused(profile)
	if profile.buffer == nil then return nil end
	return table.getn(profile.buffer) > 0
end

cbAddModule(module,"Buffer Binds","Gameplay")
