-- CityBinder - Bind File Generator for City of Heroes and City of Villains
-- Copyright (C) 2005  Jeff Sheets

-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


local module = {}

function module.bindsettings(profile)
	local typing = profile.typing
	if typing == nil then
		typing = {}
		profile.typing = typing
		typing.enable = nil
		typing.Message = "Typing..."
	end
	if typing.dialog then
		typing.dialog:show()
	else
		cbToolTip("Check this to enable AFK based Typing Messages")
		local typingenable = cbCheckbox("Enable AFK Based Typing Message?",typing.enable,
			function(_,v) if v == 1 then typing.enable = true else typing.enable = nil end end)
		cbToolTip("Choose the message to display when you are typing chat messages or commands")
		local msghbox = cbTextBox("Message",typing.Message,function(_,c,s) typing.Message = s return iup.DEFAULT end)
	
		local typdlg = iup.dialog{iup.vbox{typingenable,msghbox};title = "Chat : Typing Message"}
		typdlg:showxy(218,10)
		typdlg.close_cb = function(self) typing.dialog = nil end
		typing.dialog = typdlg
	end
end

function module.makebind(profile)
	local resetfile = profile.resetfile
	local typing = profile.typing
	resetfile:write('enter "show chat$$startchat$$afk '..typing.Message..'"\n')
	resetfile:write('/ "show chat$$slashchat$$afk '..typing.Message..'"\n')
	resetfile:write('; "show chat$$slashchat$$afk '..typing.Message..'"\n')
	resetfile:write('backspace "autoreply$$afk '..typing.Message..'"\n')
	resetfile:write('comma "show chat$$beginchat /tell $target, $$afk '..typing.Message..'"\n')
	resetfile:write('\' "quickchat$$afk '..typing.Message..'"\n')
end

function module.bindisused(profile)
	if profile.typing == nil then return nil end
	return profile.typing.enable
end

cbAddModule(module,"Typing Message","Chat")
